*** a/src/backend/parser/parse_utilcmd.c
--- b/src/backend/parser/parse_utilcmd.c
***************
*** 65,71 ****
  
  
  /* State shared by transformCreateStmt and its subroutines */
! typedef struct
  {
  	ParseState *pstate;			/* overall parser state */
  	const char *stmtType;		/* "CREATE [FOREIGN] TABLE" or "ALTER TABLE" */
--- 65,71 ----
  
  
  /* State shared by transformCreateStmt and its subroutines */
! typedef struct CreateStmtContext
  {
  	ParseState *pstate;			/* overall parser state */
  	const char *stmtType;		/* "CREATE [FOREIGN] TABLE" or "ALTER TABLE" */
***************
*** 87,93 **** typedef struct
  } CreateStmtContext;
  
  /* State shared by transformCreateSchemaStmt and its subroutines */
! typedef struct
  {
  	const char *stmtType;		/* "CREATE SCHEMA" or "ALTER SCHEMA" */
  	char	   *schemaname;		/* name of schema */
--- 87,93 ----
  } CreateStmtContext;
  
  /* State shared by transformCreateSchemaStmt and its subroutines */
! typedef struct CreateSchemaStmtContext
  {
  	const char *stmtType;		/* "CREATE SCHEMA" or "ALTER SCHEMA" */
  	char	   *schemaname;		/* name of schema */
***************
*** 491,497 **** transformColumnDefinition(CreateStmtContext *cxt, ColumnDef *column)
  									column->colname, cxt->relation->relname),
  							 parser_errposition(cxt->pstate,
  												constraint->location)));
! 				column->is_not_null = FALSE;
  				saw_nullable = true;
  				break;
  
--- 491,497 ----
  									column->colname, cxt->relation->relname),
  							 parser_errposition(cxt->pstate,
  												constraint->location)));
! 				column->is_not_null = false;
  				saw_nullable = true;
  				break;
  
***************
*** 503,509 **** transformColumnDefinition(CreateStmtContext *cxt, ColumnDef *column)
  									column->colname, cxt->relation->relname),
  							 parser_errposition(cxt->pstate,
  												constraint->location)));
! 				column->is_not_null = TRUE;
  				saw_nullable = true;
  				break;
  
--- 503,509 ----
  									column->colname, cxt->relation->relname),
  							 parser_errposition(cxt->pstate,
  												constraint->location)));
! 				column->is_not_null = true;
  				saw_nullable = true;
  				break;
  
***************
*** 678,683 **** transformInhRelation(CreateStmtContext *cxt, InhRelation *inhRelation)
--- 678,697 ----
  		def->constraints = NIL;
  
  		/*
+ 		 * FIXME strictly speaking, we need to fetch pg_constraint rows so that
+ 		 * we don't create spurious NOT NULL constraints for the primary key
+ 		 * columns.
+ 		 */
+ 		if (attribute->attnotnull)
+ 		{
+ 			Constraint *constraint = makeNode(Constraint);
+ 
+ 			constraint->contype = CONSTR_NOTNULL;
+ 			constraint->location = -1;
+ 			def->constraints = lappend(def->constraints, constraint);
+ 		}
+ 
+ 		/*
  		 * Add to column list
  		 */
  		cxt->columns = lappend(cxt->columns, def);
***************
*** 1644,1650 **** transformIndexConstraint(Constraint *constraint, CreateStmtContext *cxt)
  		{
  			/* found column in the new table; force it to be NOT NULL */
  			if (constraint->contype == CONSTR_PRIMARY)
! 				column->is_not_null = TRUE;
  		}
  		else if (SystemAttributeByName(key, cxt->hasoids) != NULL)
  		{
--- 1658,1664 ----
  		{
  			/* found column in the new table; force it to be NOT NULL */
  			if (constraint->contype == CONSTR_PRIMARY)
! 				column->is_primary_key = true;
  		}
  		else if (SystemAttributeByName(key, cxt->hasoids) != NULL)
  		{
***************
*** 2300,2305 **** transformAlterTableStmt(AlterTableStmt *stmt, const char *queryString)
--- 2314,2321 ----
  			case AT_AddColumnToView:
  				{
  					ColumnDef  *def = (ColumnDef *) cmd->def;
+ 					List       *constraints = NIL;
+ 					ListCell   *cell;
  
  					Assert(IsA(def, ColumnDef));
  					transformColumnDefinition(&cxt, def);
***************
*** 2312,2322 **** transformAlterTableStmt(AlterTableStmt *stmt, const char *queryString)
  						skipValidation = false;
  
  					/*
! 					 * All constraints are processed in other ways. Remove the
! 					 * original list
  					 */
! 					def->constraints = NIL;
  
  					newcmds = lappend(newcmds, cmd);
  					break;
  				}
--- 2328,2346 ----
  						skipValidation = false;
  
  					/*
! 					 * All constraints are processed in other ways, except NOT
! 					 * NULL.  Filter down the list so that only CONSTR_NOTNULL
! 					 * nodes remain.
  					 */
! 					foreach(cell, def->constraints)
! 					{
! 						Constraint *constraint = (Constraint *) lfirst(cell);
! 
! 						if (constraint->contype == CONSTR_NOTNULL)
! 							constraints = lappend(constraints, constraint);
! 					}
  
+ 					def->constraints = constraints;
  					newcmds = lappend(newcmds, cmd);
  					break;
  				}
*** a/src/backend/utils/adt/ruleutils.c
--- b/src/backend/utils/adt/ruleutils.c
***************
*** 1110,1122 **** pg_get_constraintdef_worker(Oid constraintId, bool fullCommand,
  
  	if (fullCommand && OidIsValid(conForm->conrelid))
  	{
! 		appendStringInfo(&buf, "ALTER TABLE ONLY %s ADD CONSTRAINT %s ",
! 						 generate_relation_name(conForm->conrelid, NIL),
! 						 quote_identifier(NameStr(conForm->conname)));
  	}
  
  	switch (conForm->contype)
  	{
  		case CONSTRAINT_FOREIGN:
  			{
  				Datum		val;
--- 1110,1160 ----
  
  	if (fullCommand && OidIsValid(conForm->conrelid))
  	{
! 		/* XXX: TODO, not sure how to handle this right now? */
! 		if (conForm->contype == CONSTRAINT_NOTNULL)
! 		{
! 			appendStringInfo(&buf, "ALTER TABLE ONLY %s ALTER COLUMN ",
! 							 generate_relation_name(conForm->conrelid, NIL));
! 		}
! 		else
! 		{
! 			appendStringInfo(&buf, "ALTER TABLE ONLY %s ADD CONSTRAINT %s ",
! 							 generate_relation_name(conForm->conrelid, NIL),
! 							 quote_identifier(NameStr(conForm->conname)));
! 		}
  	}
  
  	switch (conForm->contype)
  	{
+ 		case CONSTRAINT_NOTNULL:
+ 		{
+ 			Datum val;
+ 			bool  isnull;
+ 
+ 			/* XXX: TODO, not sure how to handle this right now? */
+ 
+ 			/* Fetch referenced column OID */
+ 			val = SysCacheGetAttr(CONSTROID, tup,
+ 								  Anum_pg_constraint_conkey, &isnull);
+ 
+ 			if (conForm->conrelid != InvalidOid)
+ 			{
+ 				/* Should not happen */
+ 				if (isnull)
+ 					elog(ERROR, "null conkey for constraint %u",
+ 						 constraintId);
+ 
+ 				/* relation constraint */
+ 				decompile_column_index_array(val, conForm->conrelid, &buf);
+ 				appendStringInfo(&buf, " SET NOT NULL");
+ 			}
+ 			else
+ 			{
+ 				/* Domain constraint */
+ 			}
+ 
+ 			break;
+ 		}
  		case CONSTRAINT_FOREIGN:
  			{
  				Datum		val;
*** a/src/bin/initdb/initdb.c
--- b/src/bin/initdb/initdb.c
***************
*** 165,170 **** static void setup_config(void);
--- 165,171 ----
  static void bootstrap_template1(void);
  static void setup_auth(void);
  static void get_set_pwd(void);
+ static void setup_notnull_constraints(void);
  static void setup_depend(void);
  static void setup_sysviews(void);
  static void setup_description(void);
***************
*** 1326,1331 **** get_set_pwd(void)
--- 1327,1372 ----
  	check_ok();
  }
  
+ static void
+ setup_notnull_constraints(void)
+ {
+ 	PG_CMD_DECL;
+ 	const char **line;
+ 	static const char *notnull_constraints_setup[] = {
+ 		/*
+ 		 * Create pg_constraint entries for all NOT NULL columns created so
+ 		 * far.  The name chosen should resemble the rules in
+ 		 * ChooseConstraintName.
+ 		 */
+ 		"INSERT INTO pg_constraint"
+ 		"     SELECT format('%s_%s_notnull', relname, attname), relnamespace,"
+ 		"            'n', 'f', 'f', 't', pg_class.oid, 0, 0, 0, ' ', ' ', ' ',"
+ 		"            't', 0, ARRAY[attnum], null, null, null, null, null,"
+ 		"            null, null"
+ 		"       FROM pg_attribute att JOIN pg_class"
+ 		"            ON (att.attrelid = pg_class.oid)"
+ 		"       WHERE attnotnull AND attnum > 0;\n",
+ 		NULL
+ 	};
+ 
+ 	fputs(_("initializing constraints ... "), stdout);
+ 	fflush(stdout);
+ 
+ 	snprintf(cmd, sizeof(cmd),
+ 			 "\"%s\" %s template1 >%s",
+ 			 backend_exec, backend_options,
+ 			 DEVNULL);
+ 
+ 	PG_CMD_OPEN;
+ 
+ 	for (line = notnull_constraints_setup; *line != NULL; line++)
+ 		PG_CMD_PUTS(*line);
+ 
+ 	PG_CMD_CLOSE;
+ 
+ 	check_ok();
+ }
+ 
  /*
   * set up pg_depend
   */
***************
*** 3269,3274 **** main(int argc, char *argv[])
--- 3310,3317 ----
  	if (pwprompt || pwfilename)
  		get_set_pwd();
  
+ 	setup_notnull_constraints();
+ 
  	setup_depend();
  
  	setup_sysviews();
*** a/src/bin/pg_dump/common.c
--- b/src/bin/pg_dump/common.c
***************
*** 439,444 **** flagInhAttrs(TableInfo *tblinfo, int numTables)
--- 439,449 ----
  					tbinfo->inhNotNull[j] = false;
  				}
  
+ 				/*
+ 				 * Clear it if NOT NULL is known to have a local definition */
+ 				if (tbinfo->localnotnull[j])
+ 					tbinfo->inhNotNull[j] = false;
+ 
  				/* Clear it if attr has local definition */
  				if (tbinfo->attislocal[j])
  					tbinfo->inhAttrs[j] = false;
*** a/src/bin/pg_dump/pg_dump.c
--- b/src/bin/pg_dump/pg_dump.c
***************
*** 1767,1773 **** dumpDatabase(Archive *AH)
  						  "datcollate, datctype, datfrozenxid, "
  						  "(SELECT spcname FROM pg_tablespace t WHERE t.oid = dattablespace) AS tablespace, "
  					  "shobj_description(oid, 'pg_database') AS description "
- 
  						  "FROM pg_database "
  						  "WHERE datname = ",
  						  username_subquery);
--- 1767,1772 ----
***************
*** 1781,1787 **** dumpDatabase(Archive *AH)
  					   "NULL AS datcollate, NULL AS datctype, datfrozenxid, "
  						  "(SELECT spcname FROM pg_tablespace t WHERE t.oid = dattablespace) AS tablespace, "
  					  "shobj_description(oid, 'pg_database') AS description "
- 
  						  "FROM pg_database "
  						  "WHERE datname = ",
  						  username_subquery);
--- 1780,1785 ----
***************
*** 4827,4832 **** getDomainConstraints(TypeInfo *tyinfo)
--- 4825,4831 ----
  	int			i_tableoid,
  				i_oid,
  				i_conname,
+ 				i_contype,
  				i_consrc;
  	int			ntups;
  
***************
*** 4843,4856 **** getDomainConstraints(TypeInfo *tyinfo)
  	query = createPQExpBuffer();
  
  	if (g_fout->remoteVersion >= 70400)
! 		appendPQExpBuffer(query, "SELECT tableoid, oid, conname, "
  						  "pg_catalog.pg_get_constraintdef(oid) AS consrc "
  						  "FROM pg_catalog.pg_constraint "
  						  "WHERE contypid = '%u'::pg_catalog.oid "
  						  "ORDER BY conname",
  						  tyinfo->dobj.catId.oid);
  	else
! 		appendPQExpBuffer(query, "SELECT tableoid, oid, conname, "
  						  "'CHECK (' || consrc || ')' AS consrc "
  						  "FROM pg_catalog.pg_constraint "
  						  "WHERE contypid = '%u'::pg_catalog.oid "
--- 4842,4855 ----
  	query = createPQExpBuffer();
  
  	if (g_fout->remoteVersion >= 70400)
! 		appendPQExpBuffer(query, "SELECT tableoid, oid, conname, contype, "
  						  "pg_catalog.pg_get_constraintdef(oid) AS consrc "
  						  "FROM pg_catalog.pg_constraint "
  						  "WHERE contypid = '%u'::pg_catalog.oid "
  						  "ORDER BY conname",
  						  tyinfo->dobj.catId.oid);
  	else
! 		appendPQExpBuffer(query, "SELECT tableoid, oid, conname, 'c' as contype, "
  						  "'CHECK (' || consrc || ')' AS consrc "
  						  "FROM pg_catalog.pg_constraint "
  						  "WHERE contypid = '%u'::pg_catalog.oid "
***************
*** 4865,4870 **** getDomainConstraints(TypeInfo *tyinfo)
--- 4864,4870 ----
  	i_tableoid = PQfnumber(res, "tableoid");
  	i_oid = PQfnumber(res, "oid");
  	i_conname = PQfnumber(res, "conname");
+ 	i_contype = PQfnumber(res, "contype");
  	i_consrc = PQfnumber(res, "consrc");
  
  	constrinfo = (ConstraintInfo *) malloc(ntups * sizeof(ConstraintInfo));
***************
*** 4882,4888 **** getDomainConstraints(TypeInfo *tyinfo)
  		constrinfo[i].dobj.namespace = tyinfo->dobj.namespace;
  		constrinfo[i].contable = NULL;
  		constrinfo[i].condomain = tyinfo;
! 		constrinfo[i].contype = 'c';
  		constrinfo[i].condef = strdup(PQgetvalue(res, i, i_consrc));
  		constrinfo[i].confrelid = InvalidOid;
  		constrinfo[i].conindex = 0;
--- 4882,4888 ----
  		constrinfo[i].dobj.namespace = tyinfo->dobj.namespace;
  		constrinfo[i].contable = NULL;
  		constrinfo[i].condomain = tyinfo;
! 		constrinfo[i].contype = *PQgetvalue(res, i, i_contype);
  		constrinfo[i].condef = strdup(PQgetvalue(res, i, i_consrc));
  		constrinfo[i].confrelid = InvalidOid;
  		constrinfo[i].conindex = 0;
***************
*** 5581,5586 **** getTableAttrs(TableInfo *tblinfo, int numTables)
--- 5581,5587 ----
  	for (i = 0; i < numTables; i++)
  	{
  		TableInfo  *tbinfo = &tblinfo[i];
+ 		int			notnulls;
  
  		/* Don't bother to collect info for sequences */
  		if (tbinfo->relkind == RELKIND_SEQUENCE)
***************
*** 5739,5744 **** getTableAttrs(TableInfo *tblinfo, int numTables)
--- 5740,5747 ----
  		tbinfo->attalign = (char *) malloc(ntups * sizeof(char));
  		tbinfo->attislocal = (bool *) malloc(ntups * sizeof(bool));
  		tbinfo->notnull = (bool *) malloc(ntups * sizeof(bool));
+ 		tbinfo->namenotnull = (char **) malloc(ntups * sizeof(char *));
+ 		tbinfo->localnotnull = (bool *) malloc(ntups * sizeof(bool));
  		tbinfo->attrdefs = (AttrDefInfo **) malloc(ntups * sizeof(AttrDefInfo *));
  		tbinfo->attoptions = (char **) malloc(ntups * sizeof(char *));
  		tbinfo->attcollation = (Oid *) malloc(ntups * sizeof(Oid));
***************
*** 5746,5751 **** getTableAttrs(TableInfo *tblinfo, int numTables)
--- 5749,5755 ----
  		tbinfo->inhAttrDef = (bool *) malloc(ntups * sizeof(bool));
  		tbinfo->inhNotNull = (bool *) malloc(ntups * sizeof(bool));
  		hasdefaults = false;
+ 		notnulls = 0;
  
  		for (j = 0; j < ntups; j++)
  		{
***************
*** 5766,5771 **** getTableAttrs(TableInfo *tblinfo, int numTables)
--- 5770,5780 ----
  			tbinfo->attalign[j] = *(PQgetvalue(res, j, i_attalign));
  			tbinfo->attislocal[j] = (PQgetvalue(res, j, i_attislocal)[0] == 't');
  			tbinfo->notnull[j] = (PQgetvalue(res, j, i_attnotnull)[0] == 't');
+ 			tbinfo->namenotnull[j] = NULL;		/* fix below */
+ 			tbinfo->localnotnull[j] = false;	/* fix below */
+ 			/* not null info is dumped separately only in 9.2 up */
+ 			if (tbinfo->notnull[j] && g_fout->remoteVersion >= 90200)
+ 				notnulls++;
  			tbinfo->attoptions[j] = strdup(PQgetvalue(res, j, i_attoptions));
  			tbinfo->attcollation[j] = atooid(PQgetvalue(res, j, i_attcollation));
  			tbinfo->attrdefs[j] = NULL; /* fix below */
***************
*** 6020,6025 **** getTableAttrs(TableInfo *tblinfo, int numTables)
--- 6029,6074 ----
  			}
  			PQclear(res);
  		}
+ 
+ 		/*
+ 		 * Get info about not null constraints
+ 		 */
+ 		if (notnulls > 0)
+ 		{
+ 			if (g_verbose)
+ 				write_msg(NULL, "finding NOT NULL constraint names for table \"%s\"\n",
+ 						  tbinfo->dobj.name);
+ 
+ 			resetPQExpBuffer(q);
+ 			appendPQExpBuffer(q, "SELECT conkey[1], conname, conislocal "
+ 							  "FROM pg_catalog.pg_constraint "
+ 							  "WHERE conrelid = '%u'::pg_catalog.oid "
+ 							  "   AND contype = 'n' "
+ 							  "ORDER BY 1",
+ 							  tbinfo->dobj.catId.oid);
+ 			res = PQexec(g_conn, q->data);
+ 			check_sql_result(res, g_conn, q->data, PGRES_TUPLES_OK);
+ 
+ 			if (PQntuples(res) != notnulls)
+ 			{
+ 				write_msg(NULL, ngettext("expected %d not null constraint on table \"%s\" but found %d\n",
+ 										 "expected %d not null constraints on table \"%s\" but found %d\n",
+ 										 notnulls),
+ 						  notnulls, tbinfo->dobj.name, PQntuples(res));
+ 				write_msg(NULL, "(The system catalogs might be corrupted.)\n");
+ 				exit_nicely();
+ 			}
+ 
+ 			for (j = 0; j < notnulls; j++)
+ 			{
+ 				int		colnum = atoi(PQgetvalue(res, j, 0));
+ 
+ 				tbinfo->namenotnull[colnum - 1] = strdup(PQgetvalue(res, j, 1));
+ 				tbinfo->localnotnull[colnum - 1] = PQgetvalue(res, j, 2)[0] == 't';
+ 			}
+ 
+ 			PQclear(res);
+ 		}
  	}
  
  	destroyPQExpBuffer(q);
***************
*** 7805,7811 **** dumpDomain(Archive *fout, TypeInfo *tyinfo)
  	selectSourceSchema(tyinfo->dobj.namespace->dobj.name);
  
  	/* Fetch domain specific details */
! 	if (g_fout->remoteVersion >= 90100)
  	{
  		/* typcollation is new in 9.1 */
  		appendPQExpBuffer(query, "SELECT t.typnotnull, "
--- 7854,7875 ----
  	selectSourceSchema(tyinfo->dobj.namespace->dobj.name);
  
  	/* Fetch domain specific details */
! 	if (g_fout->remoteVersion >= 90200)
! 	{
! 		/* NOT NULL is handled as a constraint in 9.2 */
! 		appendPQExpBuffer(query, "SELECT 'f' AS typnotnull, "
! 			"pg_catalog.format_type(t.typbasetype, t.typtypmod) AS typdefn, "
! 						  "pg_catalog.pg_get_expr(t.typdefaultbin, 'pg_catalog.pg_type'::pg_catalog.regclass) AS typdefaultbin, "
! 						  "t.typdefault, "
! 						  "CASE WHEN t.typcollation <> u.typcollation "
! 						  "THEN t.typcollation ELSE 0 END AS typcollation "
! 						  "FROM pg_catalog.pg_type t "
! 				 "LEFT JOIN pg_catalog.pg_type u ON (t.typbasetype = u.oid) "
! 						  "WHERE t.oid = '%u'::pg_catalog.oid",
! 						  tyinfo->dobj.catId.oid);
! 
! 	}
! 	else if (g_fout->remoteVersion >= 90100)
  	{
  		/* typcollation is new in 9.1 */
  		appendPQExpBuffer(query, "SELECT t.typnotnull, "
***************
*** 7904,7911 **** dumpDomain(Archive *fout, TypeInfo *tyinfo)
  		ConstraintInfo *domcheck = &(tyinfo->domChecks[i]);
  
  		if (!domcheck->separate)
! 			appendPQExpBuffer(q, "\n\tCONSTRAINT %s %s",
! 							  fmtId(domcheck->dobj.name), domcheck->condef);
  	}
  
  	appendPQExpBuffer(q, ";\n");
--- 7968,7981 ----
  		ConstraintInfo *domcheck = &(tyinfo->domChecks[i]);
  
  		if (!domcheck->separate)
! 		{
! 			if (domcheck->contype == 'c')
! 				appendPQExpBuffer(q, "\n\tCONSTRAINT %s %s",
! 								  fmtId(domcheck->dobj.name), domcheck->condef);
! 			else
! 				appendPQExpBuffer(q, "\n\tCONSTRAINT %s NOT NULL",
! 								  fmtId(domcheck->dobj.name));
! 		}
  	}
  
  	appendPQExpBuffer(q, ";\n");
***************
*** 12202,12208 **** dumpTableSchema(Archive *fout, TableInfo *tbinfo)
--- 12272,12282 ----
  									  tbinfo->attrdefs[j]->adef_expr);
  
  				if (has_notnull)
+ 				{
+ 					if (tbinfo->namenotnull[j])
+ 						appendPQExpBuffer(q, " CONSTRAINT %s", tbinfo->namenotnull[j]);
  					appendPQExpBuffer(q, " NOT NULL");
+ 				}
  			}
  		}
  
***************
*** 12888,12893 **** dumpConstraint(Archive *fout, ConstraintInfo *coninfo)
--- 12962,13005 ----
  						 NULL, NULL);
  		}
  	}
+ 	else if (coninfo->contype == 'n' && tbinfo == NULL)
+ 	{
+ 		/* NOT NULL constraint on a domain */
+ 		TypeInfo   *tyinfo = coninfo->condomain;
+ 
+ 		/* Ignore if not to be dumped separately */
+ 		if (coninfo->separate)
+ 		{
+ 			/*
+ 			 * FIXME this code path is apparently unused.  Is there any use
+ 			 * for separate NOT NULL constraints?
+ 			 */
+ 			appendPQExpBuffer(q, "ALTER DOMAIN %s\n",
+ 							  fmtId(tyinfo->dobj.name));
+ 			/* XXX we lose the constraint name */
+ 			appendPQExpBuffer(q, "    SET NOT NULL;\n");
+ 
+ 			/*
+ 			 * DROP must be fully qualified in case same name appears in
+ 			 * pg_catalog
+ 			 */
+ 			appendPQExpBuffer(delq, "ALTER DOMAIN %s.",
+ 							  fmtId(tyinfo->dobj.namespace->dobj.name));
+ 			appendPQExpBuffer(delq, "%s ",
+ 							  fmtId(tyinfo->dobj.name));
+ 			appendPQExpBuffer(delq, "DROP NOT NULL;\n");
+ 
+ 			ArchiveEntry(fout, coninfo->dobj.catId, coninfo->dobj.dumpId,
+ 						 coninfo->dobj.name,
+ 						 tyinfo->dobj.namespace->dobj.name,
+ 						 NULL,
+ 						 tyinfo->rolname, false,
+ 						 "NOT NULL CONSTRAINT", SECTION_POST_DATA,
+ 						 q->data, delq->data, NULL,
+ 						 coninfo->dobj.dependencies, coninfo->dobj.nDeps,
+ 						 NULL, NULL);
+ 		}
+ 	}
  	else
  	{
  		write_msg(NULL, "unrecognized constraint type: %c\n", coninfo->contype);
*** a/src/bin/pg_dump/pg_dump.h
--- b/src/bin/pg_dump/pg_dump.h
***************
*** 282,287 **** typedef struct _tableInfo
--- 282,289 ----
  	 * were inherited.
  	 */
  	bool	   *notnull;		/* Not null constraints on attributes */
+ 	bool	   *localnotnull;	/* whether NOT NULL constrs have local defs */
+ 	char	  **namenotnull;	/* names of the NOT NULL constraints */
  	struct _attrDefInfo **attrdefs;		/* DEFAULT expressions */
  	bool	   *inhAttrs;		/* true if each attribute is inherited */
  	bool	   *inhAttrDef;		/* true if attr's default is inherited */
*** a/src/bin/pg_dump/pg_dump_sort.c
--- b/src/bin/pg_dump/pg_dump_sort.c
***************
*** 753,759 **** repairTableAttrDefMultiLoop(DumpableObject *tableobj,
  }
  
  /*
!  * CHECK constraints on domains work just like those on tables ...
   */
  static void
  repairDomainConstraintLoop(DumpableObject *domainobj,
--- 753,759 ----
  }
  
  /*
!  * CHECK and NOT NULL constraints on domains work just like those on tables ...
   */
  static void
  repairDomainConstraintLoop(DumpableObject *domainobj,
***************
*** 928,938 **** repairDependencyLoop(DumpableObject **loop,
  		}
  	}
  
! 	/* Domain and CHECK constraint */
  	if (nLoop == 2 &&
  		loop[0]->objType == DO_TYPE &&
  		loop[1]->objType == DO_CONSTRAINT &&
! 		((ConstraintInfo *) loop[1])->contype == 'c' &&
  		((ConstraintInfo *) loop[1])->condomain == (TypeInfo *) loop[0])
  	{
  		repairDomainConstraintLoop(loop[0], loop[1]);
--- 928,939 ----
  		}
  	}
  
! 	/* Domain and CHECK or NOT NULL constraint */
  	if (nLoop == 2 &&
  		loop[0]->objType == DO_TYPE &&
  		loop[1]->objType == DO_CONSTRAINT &&
! 		(((ConstraintInfo *) loop[1])->contype == 'c' ||
! 		 ((ConstraintInfo *) loop[1])->contype == 'n') &&
  		((ConstraintInfo *) loop[1])->condomain == (TypeInfo *) loop[0])
  	{
  		repairDomainConstraintLoop(loop[0], loop[1]);
***************
*** 941,954 **** repairDependencyLoop(DumpableObject **loop,
  	if (nLoop == 2 &&
  		loop[1]->objType == DO_TYPE &&
  		loop[0]->objType == DO_CONSTRAINT &&
! 		((ConstraintInfo *) loop[0])->contype == 'c' &&
  		((ConstraintInfo *) loop[0])->condomain == (TypeInfo *) loop[1])
  	{
  		repairDomainConstraintLoop(loop[1], loop[0]);
  		return;
  	}
  
! 	/* Indirect loop involving domain and CHECK constraint */
  	if (nLoop > 2)
  	{
  		for (i = 0; i < nLoop; i++)
--- 942,956 ----
  	if (nLoop == 2 &&
  		loop[1]->objType == DO_TYPE &&
  		loop[0]->objType == DO_CONSTRAINT &&
! 		(((ConstraintInfo *) loop[0])->contype == 'c' ||
! 		 ((ConstraintInfo *) loop[0])->contype == 'n') &&
  		((ConstraintInfo *) loop[0])->condomain == (TypeInfo *) loop[1])
  	{
  		repairDomainConstraintLoop(loop[1], loop[0]);
  		return;
  	}
  
! 	/* Indirect loop involving domain and CHECK or NOT NULL constraint */
  	if (nLoop > 2)
  	{
  		for (i = 0; i < nLoop; i++)
***************
*** 958,964 **** repairDependencyLoop(DumpableObject **loop,
  				for (j = 0; j < nLoop; j++)
  				{
  					if (loop[j]->objType == DO_CONSTRAINT &&
! 						((ConstraintInfo *) loop[j])->contype == 'c' &&
  						((ConstraintInfo *) loop[j])->condomain == (TypeInfo *) loop[i])
  					{
  						repairDomainConstraintMultiLoop(loop[i], loop[j]);
--- 960,967 ----
  				for (j = 0; j < nLoop; j++)
  				{
  					if (loop[j]->objType == DO_CONSTRAINT &&
! 						(((ConstraintInfo *) loop[j])->contype == 'c' ||
! 						 ((ConstraintInfo *) loop[j])->contype == 'n') &&
  						((ConstraintInfo *) loop[j])->condomain == (TypeInfo *) loop[i])
  					{
  						repairDomainConstraintMultiLoop(loop[i], loop[j]);
*** a/src/include/catalog/pg_attribute.h
--- b/src/include/catalog/pg_attribute.h
***************
*** 127,133 **** CATALOG(pg_attribute,1249) BKI_BOOTSTRAP BKI_WITHOUT_OIDS BKI_ROWTYPE_OID(75) BK
  	 */
  	char		attalign;
  
! 	/* This flag represents the "NOT NULL" constraint */
  	bool		attnotnull;
  
  	/* Has DEFAULT value or not */
--- 127,136 ----
  	 */
  	char		attalign;
  
! 	/*
! 	 * Whether the column is nullable.  This might be from a NOT NULL
! 	 * constraint or a primary key.
! 	 */
  	bool		attnotnull;
  
  	/* Has DEFAULT value or not */
*** a/src/include/catalog/pg_constraint.h
--- b/src/include/catalog/pg_constraint.h
***************
*** 177,182 **** typedef FormData_pg_constraint *Form_pg_constraint;
--- 177,183 ----
  
  /* Valid values for contype */
  #define CONSTRAINT_CHECK			'c'
+ #define CONSTRAINT_NOTNULL			'n'
  #define CONSTRAINT_FOREIGN			'f'
  #define CONSTRAINT_PRIMARY			'p'
  #define CONSTRAINT_UNIQUE			'u'
*** a/src/include/nodes/parsenodes.h
--- b/src/include/nodes/parsenodes.h
***************
*** 493,498 **** typedef struct ColumnDef
--- 493,499 ----
  	int			inhcount;		/* number of times column is inherited */
  	bool		is_local;		/* column has local (non-inherited) def'n */
  	bool		is_not_null;	/* NOT NULL constraint specified? */
+ 	bool		is_primary_key;	/* Does it belong to a PK? */
  	bool		is_from_type;	/* column definition came from table type */
  	char		storage;		/* attstorage setting, or 0 for default */
  	Node	   *raw_default;	/* default value (untransformed parse tree) */
***************
*** 1178,1184 **** typedef enum AlterTableType
--- 1179,1188 ----
  	AT_AddColumnToView,			/* implicitly via CREATE OR REPLACE VIEW */
  	AT_ColumnDefault,			/* alter column default */
  	AT_DropNotNull,				/* alter column drop not null */
+ 	AT_DropNotNullRecurse,      /* internal to commands/tablecmds.c */
  	AT_SetNotNull,				/* alter column set not null */
+ 	AT_SetNotNullRecurse,       /* internal to commands/tablecmds.c */
+ 	AT_SetAttNotNull,			/* internal (used by DefineIndex) */
  	AT_SetStatistics,			/* alter column set statistics */
  	AT_SetOptions,				/* alter column set ( options ) */
  	AT_ResetOptions,			/* alter column reset ( options ) */
*** a/src/test/regress/sql/domain.sql
--- b/src/test/regress/sql/domain.sql
***************
*** 224,229 **** update domnotnull set col1 = null;
--- 224,239 ----
  
  drop domain dnotnulltest cascade;
  
+ create domain dnotnulltest integer constraint dnn not null;
+ 
+ select conname, contype, contypid::regtype from pg_constraint c
+    where contype = 'n' and contypid <> 0 order by 1;
+ 
+ drop domain dnotnulltest;
+ 
+ select conname, contype, contypid::regtype from pg_constraint
+    where contype = 'n' and contypid <> 0 order by 1;
+ 
  -- Test ALTER DOMAIN .. DEFAULT ..
  create table domdeftest (col1 ddef1);
  
*** a/src/test/regress/sql/inherit.sql
--- b/src/test/regress/sql/inherit.sql
***************
*** 406,408 **** select * from matest0 order by 1-id;
--- 406,545 ----
  reset enable_seqscan;
  
  drop table matest0 cascade;
+ 
+ --
+ -- Test inheritance of NOT NULL constraints
+ --
+ create table pp1 (f1 int);
+ create table cc1 (f2 text, f3 int) inherits (pp1);
+ \d cc1
+ create table cc2(f4 float) inherits(pp1,cc1);
+ \d cc2
+ 
+ -- named NOT NULL constraint
+ alter table cc1 add column a2 int constraint nn not null;
+ \d cc1
+ \d cc2
+ alter table pp1 alter column f1 set not null;
+ \d pp1
+ \d cc1
+ \d cc2
+ 
+ -- have a look at pg_constraint
+ select conrelid::regclass, conname, contype, coninhcount, conislocal from pg_constraint where contype = 'n' and conrelid::regclass in ('pp1', 'cc1', 'cc2') order by 2;
+ 
+ -- remove constraint from cc2, should fail
+ alter table cc2 alter column a2 drop not null;
+ 
+ -- remove constraint cc1, should succeed
+ alter table cc1 alter column a2 drop not null;
+ 
+ -- have a look at pg_constraint
+ select conrelid::regclass, conname, contype, coninhcount, conislocal from pg_constraint where contype = 'n' and conrelid::regclass in ('pp1', 'cc1', 'cc2') order by 2;
+ 
+ -- same for cc2
+ alter table cc2 alter column f1 drop not null;
+ 
+ -- remove from cc1, should fail again
+ alter table cc1 alter column f1 drop not null;
+ 
+ -- remove from pp1, should succeed
+ alter table pp1 alter column f1 drop not null;
+ 
+ -- have a look at pg_constraint
+ select conrelid::regclass, conname, contype, coninhcount, conislocal from pg_constraint where contype = 'n' and conrelid::regclass in ('pp1', 'cc1', 'cc2') order by 2;
+ 
+ drop table pp1 cascade;
+ 
+ -- have a look at pg_constraint, everything should be clean now
+ select conrelid::regclass, conname, contype, coninhcount, conislocal from pg_constraint where contype = 'n' and conrelid::regclass in ('pp1', 'cc1', 'cc2') order by 2;
+ 
+ --
+ -- test inherit/deinherit
+ --
+ create table parent(f1 int);
+ create table child1(f1 int not null);
+ create table child2(f1 int);
+ 
+ -- child1 should have not null constraint
+ alter table child1 inherit parent;
+ 
+ -- should fail, missing NOT NULL constraint
+ alter table child2 inherit child1;
+ 
+ alter table child2 alter column f1 set not null;
+ alter table child2 inherit child1;
+ 
+ -- add NOT NULL constraint recursively
+ alter table parent alter column f1 set not null;
+ 
+ \d parent
+ \d child1
+ \d child2
+ 
+ select conrelid::regclass, conname, contype, coninhcount, conislocal from pg_constraint where contype = 'n' and conrelid::regclass in ('parent', 'child1', 'child2') order by 2;
+ 
+ --
+ -- test deinherit procedure
+ --
+ 
+ -- deinherit child1
+ alter table child1 no inherit parent;
+ \d parent
+ \d child1
+ \d child2
+ select conrelid::regclass, conname, contype, coninhcount, conislocal from pg_constraint where contype = 'n' and conrelid::regclass in ('parent', 'child1', 'child2') order by 2;
+ 
+ -- test inhcount of child2, should fail
+ alter table child2 alter f1 drop not null;
+ 
+ -- should succeed
+ 
+ drop table parent;
+ drop table child1 cascade;
+ 
+ --
+ -- test multi inheritance tree
+ --
+ create table parent(f1 int not null);
+ create table c1() inherits(parent);
+ create table c2() inherits(parent);
+ create table d1() inherits(c1, c2);
+ 
+ -- show constraint info
+ select conrelid::regclass, conname, contype, coninhcount, conislocal from pg_constraint where contype = 'n' and conrelid::regclass in ('parent', 'c1', 'c2', 'd1') order by 2;
+ 
+ drop table parent cascade;
+ 
+ -- test child table with inherited columns and
+ -- with explicitely specified not null constraints
+ create table parent1(f1 int);
+ create table parent2(f2 text);
+ create table child(f1 int not null, f2 text not null) inherits(parent1, parent2);
+ 
+ -- show constraint info
+ select conrelid::regclass, conname, contype, coninhcount, conislocal, conkey from pg_constraint where contype = 'n' and conrelid::regclass in ('parent1', 'parent2', 'child') order by 2;
+ 
+ -- also drops child table
+ drop table parent1 cascade;
+ drop table parent2;
+ 
+ -- test multi layer inheritance tree
+ create table p1(f1 int not null);
+ create table p2(f1 int not null);
+ create table p3(f2 int);
+ create table p4(f1 int not null, f3 text not null);
+ 
+ create table c1() inherits(p1, p2, p3, p4);
+ 
+ -- constraint on f1 should have three parents
+ select conrelid::regclass, conname, contype, coninhcount, conislocal, conkey from pg_constraint where contype = 'n' and conrelid::regclass in ('p1', 'p2', 'p3', 'p4', 'c1') order by 1, 2;
+ 
+ create table d1(a int not null, f1 int) inherits(p3, c1);
+ 
+ select conrelid::regclass, conname, contype, coninhcount, conislocal, conkey from pg_constraint where contype = 'n' and conrelid::regclass in ('p1', 'p2', 'p3', 'p4', 'c1', 'd1') order by 1, 2;
+ 
+ drop table p1 cascade;
+ drop table p2;
+ drop table p3;
+ drop table p4;
